#ifndef LOCAL_H
#define LOCAL_H

/* local.h - various defines
 * Division of Cancer Prevention & Control, NCI
 */

/* Revision history:
 * 1.21  tam  12/28/90  add byte, word
 * 1.20  tam  10/11/90  add math.h & limits.h
 * 1.19  tam  09/14/90  move io.h, stat.h, types.h, process.h to environ.h
 * 1.18  tam  08/24/90  add environ.h
 * 1.17  tam  08/14/90  split off pckeys.h
 * 1.16  tam  06/19/90  change extended key offset to 256
 * 1.15  tam  11/02/89  add ALTU
 * 1.14  tam  10/13/89  add #include <types.h>, <stat.h>, <io.h>
 * 1.13  tam  08/17/89  add ON, OFF, XON, XOFF, ALTG, ALTO
 * 1.12  tam  08/03/89  add more ALT defines
 * 1.11  tam  01/27/89  add TAB, ALTT defines
 * 1.1   tam  11/12/88  remove screen & strlocal function prototypes
 * 1.0   tam  08/03/88  first release
 */

/* ANSI headers */
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <limits.h>

/* environment specific header */
#include <environ.h>

/* typedefs */
typedef short boolean;
typedef char  *string;
typedef unsigned char byte;
typedef unsigned int  word;

/* miscellaneous defines */
#define FIRST        0
#define NOMATCH      -1
#define SUCCESS      0
#define FAILURE      -1
#define TRUE         1
#define FALSE        0
#define FOREVER      for (;;)
#define NOTSAME      != 0
#define SAME         == 0
#define UPMASK       '\x5f'
#define MAXLINE      81
#define MAXPRINT     256
#define ON           1
#define OFF          0

#endif /* local.h */

