;netbios.h - defines for NETBIOS calls
;adapted from Nance B., Network Programming in C, Carmel, IN: Que, 1990
;Division of Cancer Prevention & Control, NCI

;Revision history:
;1.00  tam  01/31/91  first release

;Program notes:
;The capitalizations of the NCB structure and defines is consistent with
;the 3Com documentation and not DCPC standards!

;constants
NETBIOS_NAME_LEN EQU 16
MAX_PACKET       EQU 512
MAX_NB_NAMES     EQU 15

;commands
RECEIVE_DATAGRAM EQU 161
SEND_DATAGRAM    EQU 0a0h

;Ncb structure
NCB_STRUC  STRUC
NCB_COMMAND  DB 0
NCB_RETCODE  DB 0
NCB_LSN      DB 0
NCB_NUM      DB 0
NCB_BUF_OFF  DW 0
NCB_BUF_SEG  DW 0
NCB_LENGTH   DW 0
NCB_CALLNAME DB NETBIOS_NAME_LEN DUP (0)
NCB_NAME     DB NETBIOS_NAME_LEN DUP (0)
NCB_RTO      DB 0
NCB_STO      DB 0
NCB_POST_OFF DW 0
NCB_POST_SEG DW 0
NCB_LANA_NUM DB 0
NCB_CMD_CPLT DB 0
NCB_RESERVE  DB 14 DUP (0)
NCB_STRUC  ENDS


