/* netdelus.c - delete %username% & %home_server% as NETBIOS names
 * Thomas A. Marciniak, M.D. = ytm@nihccpc1.bitnet
 * Division of Cancer Prevention & Control, NCI
 */

/* Revision history:
 * 1.02  ytm  02/01/91  add both user & server
 * 1.01  ytm  01/31/91  eliminate post routine
 * 1.00  ytm  01/31/91  first release
 */

/* Program notes:
 * Current versions are specific for TurboC.
 */

#include <local.h>                      /* standard definitions */
#include "netbios.h"

/* status structure */
#define STATUS_NOUSER   100
#define STATUS_NOSERVER 101
#define STATUS_UNKNOWN  0xff
#define STATUS_STRUCT struct status
typedef STATUS_STRUCT
  {
  word   wCode;
  string sText;
  };
STATUS_STRUCT aStatus[] =
  {
  {0,  "OK"},
  {21, "not found"},
  {STATUS_NOUSER, "NO username!"},
  {STATUS_NOSERVER, "NO home_server!"},
  {STATUS_UNKNOWN, "?"}
  };

/* globals */
NCB     Ncb;

/* function prototypes */
short main(void);
word NetDelName(string sName);

/* add a name to the network */
word NetDelName(string sName)
{
string s, t;
printf("Deleting %s:  ", sName);
memset(&Ncb, 0, sizeof(NCB));
Ncb.NCB_COMMAND = DELETE_NAME_WAIT;
strncpy(Ncb.NCB_NAME, sName, NETBIOS_NAME_LEN);
for (s = Ncb.NCB_NAME, t = s + NETBIOS_NAME_LEN - 1; s < t; s++)
  *s = ((*s) ? toupper(*s) : ' ');
Ncb.NCB_CMD_CPLT = STATUS_UNKNOWN;
_ES = FP_SEG(&Ncb);
_BX = FP_OFF(&Ncb);
_AX = 0x0100;
geninterrupt(0x5c);
if (Ncb.NCB_CMD_CPLT) printf("FAILED\n");
else printf("deleted\n");
return(Ncb.NCB_CMD_CPLT);
} /* NetDelName */ 

/* main */
short main(void)
{
char   caServGroup[NETBIOS_NAME_LEN];
short  i;
string s;
word   wStatus;
printf("Netdelus v1.01\n");
if (getenv("USERNAME") == NULL) wStatus = STATUS_NOUSER;
else if (strlen(getenv("HOME_SERVER")) < 5) wStatus = STATUS_NOSERVER;
else if ((wStatus = NetDelName(getenv("USERNAME"))) == 0)
  {
  strcpy(caServGroup, getenv("HOME_SERVER"));
  s = caServGroup;
  *s++ = 'U';
  *s++ = 'S';
  *s++ = 'E';
  *s = 'R';
  wStatus = NetDelName(caServGroup);
  }
for (i = 0; *(aStatus[i].sText) != '?'; i++)
  if (aStatus[i].wCode == wStatus) break;
printf("Netdelus status: %s (%d)\n", aStatus[i].sText, Ncb.NCB_CMD_CPLT);
return(i);
} /* main */


