#ifndef PCKEYS_H
#define PCKEYS_H

/* pckeys.h - codes for IBM PC keys using GETKEY macro
 * Division of Cancer Prevention & Control, NCI
 */

/* Revision history:
 * 1.02  tam  11/09/90  add DELKEY
 * 1.01  tam  10/15/90  add ALTL
 * 1.0   tam  08/24/90  split off pckeys.h from local.h
 */

/* macro */
#define GETKEY(ch) (ch = (((ch = getch()) == '\0') ? (getch() + 256) : (ch)))

/* key codes */
#define UPARROW      328 
#define DOWNARROW    336
#define LEFTARROW    331
#define RIGHTARROW   333
#define HOMEKEY      327
#define ENDKEY       335
#define DELKEY       339
#define PGUP         329
#define PGDN         337
#define CTLC         3
#define CTLE         5
#define BELL         7
#define BS           8
#define TAB          9
#define NEWLINE      10
#define LF           10
#define FF           12
#define CR           13
#define XON          17
#define XOFF         18
#define CTLZ         26
#define ESC          27
#define SPACE        32
#define DEL          127
#define ALTA         286
#define ALTB         304
#define ALTC         302
#define ALTD         288
#define ALTG         290
#define ALTH         291
#define ALTL         294
#define ALTO         280
#define ALTR         285
#define ALTS         287
#define ALTT         276
#define ALTU         278
#define ALTX         301
#define F1           315
#define F2           316
#define F3           317
#define F4           318
#define F5           319
#define F6           320
#define F7           321
#define F8           322
#define F9           323
#define F10          324

#endif /* pckeys.h */

